/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"io"
)

// Model holds all objects
type Model struct {
	mThing map[string]owl.Thing
	mTimeTemporalEntity map[string]TimeTemporalEntity
	mTimeTemporalUnit map[string]TimeTemporalUnit
	mSarefEnergyMeter map[string]SarefEnergyMeter
	mSarefCommand map[string]SarefCommand
	mSarefEnergy map[string]SarefEnergy
	mSarefToggleCommand map[string]SarefToggleCommand
	mSarefDoorSwitch map[string]SarefDoorSwitch
	mSarefLight map[string]SarefLight
	mSarefCloseState map[string]SarefCloseState
	mSarefService map[string]SarefService
	mSarefAppliance map[string]SarefAppliance
	mTimeProperInterval map[string]TimeProperInterval
	mTimeMonthOfYear map[string]TimeMonthOfYear
	mSarefOffCommand map[string]SarefOffCommand
	mSarefEventFunction map[string]SarefEventFunction
	mSarefActuator map[string]SarefActuator
	mSarefSensingFunction map[string]SarefSensingFunction
	mSarefMultimedia map[string]SarefMultimedia
	mSarefState map[string]SarefState
	mSarefLightingDevice map[string]SarefLightingDevice
	mSarefPressure map[string]SarefPressure
	mTimeTemporalPosition map[string]TimeTemporalPosition
	mSarefGetMeterDataCommand map[string]SarefGetMeterDataCommand
	mSarefEnergyRelated map[string]SarefEnergyRelated
	mSarefGetCommand map[string]SarefGetCommand
	mTimeGeneralDateTimeDescription map[string]TimeGeneralDateTimeDescription
	mSarefSensor map[string]SarefSensor
	mSarefOccupancy map[string]SarefOccupancy
	mTimeDateTimeDescription map[string]TimeDateTimeDescription
	mSarefPressureUnit map[string]SarefPressureUnit
	mSarefTask map[string]SarefTask
	mSarefProperty map[string]SarefProperty
	mSarefCurrency map[string]SarefCurrency
	mSarefStopCommand map[string]SarefStopCommand
	mSarefGetMeterHistoryCommand map[string]SarefGetMeterHistoryCommand
	mTimePosition map[string]TimePosition
	mSarefDevice map[string]SarefDevice
	mSarefSetLevelCommand map[string]SarefSetLevelCommand
	mSarefMultiLevelState map[string]SarefMultiLevelState
	mSarefTemperatureSensor map[string]SarefTemperatureSensor
	mSarefMotion map[string]SarefMotion
	mSarefLevelControlFunction map[string]SarefLevelControlFunction
	mSarefBuildingRelated map[string]SarefBuildingRelated
	mSarefGetSensingDataCommand map[string]SarefGetSensingDataCommand
	mSarefOpenCloseFunction map[string]SarefOpenCloseFunction
	mSarefNetwork map[string]SarefNetwork
	mSarefPower map[string]SarefPower
	mSarefOnCommand map[string]SarefOnCommand
	mSarefProfile map[string]SarefProfile
	mSarefUnitOfMeasure map[string]SarefUnitOfMeasure
	mSarefFunction map[string]SarefFunction
	mSarefTemperatureUnit map[string]SarefTemperatureUnit
	mSarefMicroRenewable map[string]SarefMicroRenewable
	mSarefStorage map[string]SarefStorage
	mSarefCloseCommand map[string]SarefCloseCommand
	mSarefOnOffState map[string]SarefOnOffState
	mTimeDuration map[string]TimeDuration
	mSarefStepUpCommand map[string]SarefStepUpCommand
	mSarefSmokeSensor map[string]SarefSmokeSensor
	mSarefPrice map[string]SarefPrice
	mTimeTRS map[string]TimeTRS
	mSarefCommodity map[string]SarefCommodity
	mSarefActuatingFunction map[string]SarefActuatingFunction
	mSarefIlluminanceUnit map[string]SarefIlluminanceUnit
	mSarefGetCurrentMeterValueCommand map[string]SarefGetCurrentMeterValueCommand
	mSarefCoal map[string]SarefCoal
	mSarefTemperature map[string]SarefTemperature
	mSarefOpenCommand map[string]SarefOpenCommand
	mSarefGas map[string]SarefGas
	mTimeDayOfWeek map[string]TimeDayOfWeek
	mSarefHVAC map[string]SarefHVAC
	mSarefSwitch map[string]SarefSwitch
	mSarefOnState map[string]SarefOnState
	mSarefOffState map[string]SarefOffState
	mTimeDurationDescription map[string]TimeDurationDescription
	mSarefSetRelativeLevelCommand map[string]SarefSetRelativeLevelCommand
	mSarefSwitchOnService map[string]SarefSwitchOnService
	mSarefElectricity map[string]SarefElectricity
	mSarefTime map[string]SarefTime
	mSarefStartStopFunction map[string]SarefStartStopFunction
	mSarefStartStopState map[string]SarefStartStopState
	mSarefGenerator map[string]SarefGenerator
	mTimeGeneralDurationDescription map[string]TimeGeneralDurationDescription
	mSarefMeteringFunction map[string]SarefMeteringFunction
	mSarefFunctionRelated map[string]SarefFunctionRelated
	mSarefPauseCommand map[string]SarefPauseCommand
	mSarefPowerUnit map[string]SarefPowerUnit
	mSarefNotifyCommand map[string]SarefNotifyCommand
	mSarefMeasurement map[string]SarefMeasurement
	mSarefOpenCloseState map[string]SarefOpenCloseState
	mTimeInstant map[string]TimeInstant
	mSarefHumidity map[string]SarefHumidity
	mSarefOnOffFunction map[string]SarefOnOffFunction
	mSarefStopState map[string]SarefStopState
	mSarefWashingMachine map[string]SarefWashingMachine
	mSarefLightSwitch map[string]SarefLightSwitch
	mTimeTemporalDuration map[string]TimeTemporalDuration
	mTimeZone map[string]TimeZone
	mSarefSmoke map[string]SarefSmoke
	mSarefEnergyUnit map[string]SarefEnergyUnit
	mSarefStartState map[string]SarefStartState
	mSarefStartCommand map[string]SarefStartCommand
	mSarefOpenState map[string]SarefOpenState
	mSarefLoad map[string]SarefLoad
	mSarefMeter map[string]SarefMeter
	mSarefSetAbsoluteLevelCommand map[string]SarefSetAbsoluteLevelCommand
	mTimeInterval map[string]TimeInterval
	mSarefWater map[string]SarefWater
	mSarefStepDownCommand map[string]SarefStepDownCommand
	mTimeDateTimeInterval map[string]TimeDateTimeInterval
}

// NewModel creates a new model and initializes class maps
func NewModel() (mod *Model) {
	mod = &Model{}
	mod.mThing = make(map[string]owl.Thing)
	mod.mTimeMonthOfYear = make(map[string]TimeMonthOfYear)
	mod.mSarefService = make(map[string]SarefService)
	mod.mSarefAppliance = make(map[string]SarefAppliance)
	mod.mTimeProperInterval = make(map[string]TimeProperInterval)
	mod.mSarefPressure = make(map[string]SarefPressure)
	mod.mSarefOffCommand = make(map[string]SarefOffCommand)
	mod.mSarefEventFunction = make(map[string]SarefEventFunction)
	mod.mSarefActuator = make(map[string]SarefActuator)
	mod.mSarefSensingFunction = make(map[string]SarefSensingFunction)
	mod.mSarefMultimedia = make(map[string]SarefMultimedia)
	mod.mSarefState = make(map[string]SarefState)
	mod.mSarefLightingDevice = make(map[string]SarefLightingDevice)
	mod.mTimeTemporalPosition = make(map[string]TimeTemporalPosition)
	mod.mTimeGeneralDateTimeDescription = make(map[string]TimeGeneralDateTimeDescription)
	mod.mSarefGetMeterDataCommand = make(map[string]SarefGetMeterDataCommand)
	mod.mSarefEnergyRelated = make(map[string]SarefEnergyRelated)
	mod.mSarefGetCommand = make(map[string]SarefGetCommand)
	mod.mSarefSensor = make(map[string]SarefSensor)
	mod.mSarefOccupancy = make(map[string]SarefOccupancy)
	mod.mSarefCurrency = make(map[string]SarefCurrency)
	mod.mTimeDateTimeDescription = make(map[string]TimeDateTimeDescription)
	mod.mSarefPressureUnit = make(map[string]SarefPressureUnit)
	mod.mSarefTask = make(map[string]SarefTask)
	mod.mSarefProperty = make(map[string]SarefProperty)
	mod.mSarefStopCommand = make(map[string]SarefStopCommand)
	mod.mSarefTemperatureSensor = make(map[string]SarefTemperatureSensor)
	mod.mSarefGetMeterHistoryCommand = make(map[string]SarefGetMeterHistoryCommand)
	mod.mTimePosition = make(map[string]TimePosition)
	mod.mSarefDevice = make(map[string]SarefDevice)
	mod.mSarefSetLevelCommand = make(map[string]SarefSetLevelCommand)
	mod.mSarefMultiLevelState = make(map[string]SarefMultiLevelState)
	mod.mSarefBuildingRelated = make(map[string]SarefBuildingRelated)
	mod.mSarefMotion = make(map[string]SarefMotion)
	mod.mSarefLevelControlFunction = make(map[string]SarefLevelControlFunction)
	mod.mSarefGetSensingDataCommand = make(map[string]SarefGetSensingDataCommand)
	mod.mSarefOpenCloseFunction = make(map[string]SarefOpenCloseFunction)
	mod.mSarefNetwork = make(map[string]SarefNetwork)
	mod.mSarefPower = make(map[string]SarefPower)
	mod.mSarefOnCommand = make(map[string]SarefOnCommand)
	mod.mSarefProfile = make(map[string]SarefProfile)
	mod.mSarefMicroRenewable = make(map[string]SarefMicroRenewable)
	mod.mSarefUnitOfMeasure = make(map[string]SarefUnitOfMeasure)
	mod.mSarefFunction = make(map[string]SarefFunction)
	mod.mSarefTemperatureUnit = make(map[string]SarefTemperatureUnit)
	mod.mTimeDuration = make(map[string]TimeDuration)
	mod.mSarefStorage = make(map[string]SarefStorage)
	mod.mSarefCloseCommand = make(map[string]SarefCloseCommand)
	mod.mSarefOnOffState = make(map[string]SarefOnOffState)
	mod.mSarefStepUpCommand = make(map[string]SarefStepUpCommand)
	mod.mSarefSmokeSensor = make(map[string]SarefSmokeSensor)
	mod.mSarefPrice = make(map[string]SarefPrice)
	mod.mTimeTRS = make(map[string]TimeTRS)
	mod.mSarefCommodity = make(map[string]SarefCommodity)
	mod.mSarefActuatingFunction = make(map[string]SarefActuatingFunction)
	mod.mSarefIlluminanceUnit = make(map[string]SarefIlluminanceUnit)
	mod.mSarefGetCurrentMeterValueCommand = make(map[string]SarefGetCurrentMeterValueCommand)
	mod.mSarefCoal = make(map[string]SarefCoal)
	mod.mSarefTemperature = make(map[string]SarefTemperature)
	mod.mSarefOpenCommand = make(map[string]SarefOpenCommand)
	mod.mSarefOffState = make(map[string]SarefOffState)
	mod.mSarefGas = make(map[string]SarefGas)
	mod.mTimeDayOfWeek = make(map[string]TimeDayOfWeek)
	mod.mSarefHVAC = make(map[string]SarefHVAC)
	mod.mSarefSwitch = make(map[string]SarefSwitch)
	mod.mSarefOnState = make(map[string]SarefOnState)
	mod.mSarefTime = make(map[string]SarefTime)
	mod.mTimeDurationDescription = make(map[string]TimeDurationDescription)
	mod.mSarefSetRelativeLevelCommand = make(map[string]SarefSetRelativeLevelCommand)
	mod.mSarefSwitchOnService = make(map[string]SarefSwitchOnService)
	mod.mSarefElectricity = make(map[string]SarefElectricity)
	mod.mTimeGeneralDurationDescription = make(map[string]TimeGeneralDurationDescription)
	mod.mSarefStartStopFunction = make(map[string]SarefStartStopFunction)
	mod.mSarefStartStopState = make(map[string]SarefStartStopState)
	mod.mSarefGenerator = make(map[string]SarefGenerator)
	mod.mSarefMeteringFunction = make(map[string]SarefMeteringFunction)
	mod.mSarefPowerUnit = make(map[string]SarefPowerUnit)
	mod.mSarefFunctionRelated = make(map[string]SarefFunctionRelated)
	mod.mSarefPauseCommand = make(map[string]SarefPauseCommand)
	mod.mSarefNotifyCommand = make(map[string]SarefNotifyCommand)
	mod.mSarefMeasurement = make(map[string]SarefMeasurement)
	mod.mSarefOpenCloseState = make(map[string]SarefOpenCloseState)
	mod.mSarefOnOffFunction = make(map[string]SarefOnOffFunction)
	mod.mTimeInstant = make(map[string]TimeInstant)
	mod.mSarefHumidity = make(map[string]SarefHumidity)
	mod.mSarefWashingMachine = make(map[string]SarefWashingMachine)
	mod.mSarefStopState = make(map[string]SarefStopState)
	mod.mSarefStartCommand = make(map[string]SarefStartCommand)
	mod.mSarefLightSwitch = make(map[string]SarefLightSwitch)
	mod.mTimeTemporalDuration = make(map[string]TimeTemporalDuration)
	mod.mTimeZone = make(map[string]TimeZone)
	mod.mSarefSmoke = make(map[string]SarefSmoke)
	mod.mSarefEnergyUnit = make(map[string]SarefEnergyUnit)
	mod.mSarefStartState = make(map[string]SarefStartState)
	mod.mSarefOpenState = make(map[string]SarefOpenState)
	mod.mSarefLoad = make(map[string]SarefLoad)
	mod.mSarefMeter = make(map[string]SarefMeter)
	mod.mSarefSetAbsoluteLevelCommand = make(map[string]SarefSetAbsoluteLevelCommand)
	mod.mTimeInterval = make(map[string]TimeInterval)
	mod.mSarefWater = make(map[string]SarefWater)
	mod.mSarefStepDownCommand = make(map[string]SarefStepDownCommand)
	mod.mTimeDateTimeInterval = make(map[string]TimeDateTimeInterval)
	mod.mSarefToggleCommand = make(map[string]SarefToggleCommand)
	mod.mTimeTemporalEntity = make(map[string]TimeTemporalEntity)
	mod.mTimeTemporalUnit = make(map[string]TimeTemporalUnit)
	mod.mSarefEnergyMeter = make(map[string]SarefEnergyMeter)
	mod.mSarefCommand = make(map[string]SarefCommand)
	mod.mSarefEnergy = make(map[string]SarefEnergy)
	mod.mSarefDoorSwitch = make(map[string]SarefDoorSwitch)
	mod.mSarefLight = make(map[string]SarefLight)
	mod.mSarefCloseState = make(map[string]SarefCloseState)
	return
}

// Exist checks for the existance of a resource by the given iri
func (mod *Model) Exist(iri string) (ret bool) {
	_, ret = mod.mThing[iri]
	return
}

// NewModelFromTTL creates a new model from a ttl io reader
func NewModelFromTTL(input io.Reader) (mod *Model, err error) {
	triples, err := rdf.DecodeTTL(input)
	if err != nil {
		return
	}
	g, err := rdf.NewGraph(triples)
	if err != nil {
		return
	}
	mod, err = NewModelFromGraph(g)
	return
}

// NewModelFromJSONLD creates a new model from a jsonld io reader
func NewModelFromJSONLD(input io.Reader) (mod *Model, err error) {
	triples, err := rdf.DecodeJSONLD(input)
	if err != nil {
		return
	}
	g, err := rdf.NewGraph(triples)
	if err != nil {
		return
	}
	mod, err = NewModelFromGraph(g)
	return
}

// NewModelFromGraph creates a new model from a owl graph
func NewModelFromGraph(g rdf.Graph) (mod *Model, err error) {
	mod = NewModel()
	for i := range g.Nodes {
		for j := range g.Nodes[i].Edge {
			if g.Nodes[i].Edge[j].Pred.String() == "http://www.w3.org/1999/02/22-rdf-syntax-ns#type" {
				switch g.Nodes[i].Edge[j].Object.Term.String() {
				case "https://w3id.org/saref#EnergyUnit":
					mod.NewSarefEnergyUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StartState":
					mod.NewSarefStartState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StartCommand":
					mod.NewSarefStartCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#LightSwitch":
					mod.NewSarefLightSwitch(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TemporalDuration":
					mod.NewTimeTemporalDuration(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TimeZone":
					mod.NewTimeZone(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Smoke":
					mod.NewSarefSmoke(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Load":
					mod.NewSarefLoad(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OpenState":
					mod.NewSarefOpenState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SetAbsoluteLevelCommand":
					mod.NewSarefSetAbsoluteLevelCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#Interval":
					mod.NewTimeInterval(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Meter":
					mod.NewSarefMeter(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StepDownCommand":
					mod.NewSarefStepDownCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#DateTimeInterval":
					mod.NewTimeDateTimeInterval(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Water":
					mod.NewSarefWater(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Command":
					mod.NewSarefCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Energy":
					mod.NewSarefEnergy(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#ToggleCommand":
					mod.NewSarefToggleCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TemporalEntity":
					mod.NewTimeTemporalEntity(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TemporalUnit":
					mod.NewTimeTemporalUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#EnergyMeter":
					mod.NewSarefEnergyMeter(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Light":
					mod.NewSarefLight(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#CloseState":
					mod.NewSarefCloseState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#DoorSwitch":
					mod.NewSarefDoorSwitch(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Appliance":
					mod.NewSarefAppliance(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#ProperInterval":
					mod.NewTimeProperInterval(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#MonthOfYear":
					mod.NewTimeMonthOfYear(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Service":
					mod.NewSarefService(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#State":
					mod.NewSarefState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#LightingDevice":
					mod.NewSarefLightingDevice(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Pressure":
					mod.NewSarefPressure(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OffCommand":
					mod.NewSarefOffCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#EventFunction":
					mod.NewSarefEventFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Actuator":
					mod.NewSarefActuator(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SensingFunction":
					mod.NewSarefSensingFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Multimedia":
					mod.NewSarefMultimedia(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TemporalPosition":
					mod.NewTimeTemporalPosition(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#EnergyRelated":
					mod.NewSarefEnergyRelated(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#GetCommand":
					mod.NewSarefGetCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#GeneralDateTimeDescription":
					mod.NewTimeGeneralDateTimeDescription(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#GetMeterDataCommand":
					mod.NewSarefGetMeterDataCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Occupancy":
					mod.NewSarefOccupancy(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Sensor":
					mod.NewSarefSensor(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Task":
					mod.NewSarefTask(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Property":
					mod.NewSarefProperty(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Currency":
					mod.NewSarefCurrency(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#DateTimeDescription":
					mod.NewTimeDateTimeDescription(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#PressureUnit":
					mod.NewSarefPressureUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StopCommand":
					mod.NewSarefStopCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SetLevelCommand":
					mod.NewSarefSetLevelCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#MultiLevelState":
					mod.NewSarefMultiLevelState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#TemperatureSensor":
					mod.NewSarefTemperatureSensor(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#GetMeterHistoryCommand":
					mod.NewSarefGetMeterHistoryCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TimePosition":
					mod.NewTimePosition(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Device":
					mod.NewSarefDevice(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#LevelControlFunction":
					mod.NewSarefLevelControlFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#BuildingRelated":
					mod.NewSarefBuildingRelated(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Motion":
					mod.NewSarefMotion(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OpenCloseFunction":
					mod.NewSarefOpenCloseFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Network":
					mod.NewSarefNetwork(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#GetSensingDataCommand":
					mod.NewSarefGetSensingDataCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OnCommand":
					mod.NewSarefOnCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Profile":
					mod.NewSarefProfile(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Power":
					mod.NewSarefPower(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Function":
					mod.NewSarefFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#TemperatureUnit":
					mod.NewSarefTemperatureUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#MicroRenewable":
					mod.NewSarefMicroRenewable(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#UnitOfMeasure":
					mod.NewSarefUnitOfMeasure(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#CloseCommand":
					mod.NewSarefCloseCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OnOffState":
					mod.NewSarefOnOffState(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#Duration":
					mod.NewTimeDuration(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Storage":
					mod.NewSarefStorage(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SmokeSensor":
					mod.NewSarefSmokeSensor(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Price":
					mod.NewSarefPrice(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StepUpCommand":
					mod.NewSarefStepUpCommand(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#TRS":
					mod.NewTimeTRS(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#ActuatingFunction":
					mod.NewSarefActuatingFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#IlluminanceUnit":
					mod.NewSarefIlluminanceUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Commodity":
					mod.NewSarefCommodity(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Coal":
					mod.NewSarefCoal(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Temperature":
					mod.NewSarefTemperature(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#GetCurrentMeterValueCommand":
					mod.NewSarefGetCurrentMeterValueCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OpenCommand":
					mod.NewSarefOpenCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Switch":
					mod.NewSarefSwitch(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OnState":
					mod.NewSarefOnState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OffState":
					mod.NewSarefOffState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Gas":
					mod.NewSarefGas(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#DayOfWeek":
					mod.NewTimeDayOfWeek(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#HVAC":
					mod.NewSarefHVAC(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SwitchOnService":
					mod.NewSarefSwitchOnService(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Electricity":
					mod.NewSarefElectricity(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Time":
					mod.NewSarefTime(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#DurationDescription":
					mod.NewTimeDurationDescription(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#SetRelativeLevelCommand":
					mod.NewSarefSetRelativeLevelCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StartStopState":
					mod.NewSarefStartStopState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Generator":
					mod.NewSarefGenerator(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#GeneralDurationDescription":
					mod.NewTimeGeneralDurationDescription(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StartStopFunction":
					mod.NewSarefStartStopFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#MeteringFunction":
					mod.NewSarefMeteringFunction(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#FunctionRelated":
					mod.NewSarefFunctionRelated(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#PauseCommand":
					mod.NewSarefPauseCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#PowerUnit":
					mod.NewSarefPowerUnit(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#NotifyCommand":
					mod.NewSarefNotifyCommand(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OpenCloseState":
					mod.NewSarefOpenCloseState(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Measurement":
					mod.NewSarefMeasurement(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#OnOffFunction":
					mod.NewSarefOnOffFunction(g.Nodes[i].Term.String())
				case "http://www.w3.org/2006/time#Instant":
					mod.NewTimeInstant(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#Humidity":
					mod.NewSarefHumidity(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#WashingMachine":
					mod.NewSarefWashingMachine(g.Nodes[i].Term.String())
				case "https://w3id.org/saref#StopState":
					mod.NewSarefStopState(g.Nodes[i].Term.String())
				default:
				}
			}
		}
	}
	for i := range g.Nodes {
		if res, ok := mod.mThing[g.Nodes[i].Term.String()]; ok {
			res.InitFromNode(g.Nodes[i])
		}
	}
	return
}

// ToGraph extracts an owl graph from an existing model
func (mod* Model) ToGraph() (g *rdf.Graph) {
	g = &rdf.Graph{}
	g.Nodes = make(map[string]*rdf.Node)
	for i := range mod.mThing {
		mod.mThing[i].ToGraph(g)
	}
	return
}

// ToTTL writes a ttl file from an existing model
func (mod* Model) ToTTL(output io.Writer) (err error) {
	g := mod.ToGraph()
	newTriples := g.ToTriples()
	err = rdf.EncodeTTL(newTriples, output)
	return
}

// ToJSONLD writes a jsonld file from an existing model
func (mod* Model) ToJSONLD(output io.Writer) (err error) {
	g := mod.ToGraph()
	newTriples := g.ToTriples()
	err = rdf.EncodeJSONLD(newTriples, output)
	return
}

// DeleteObject deletes an object from the model along with its references
func (mod *Model) DeleteObject(obj owl.Thing) (err error) {
	if !mod.Exist(obj.IRI()) {
		return
	}
	g := mod.ToGraph()
	n := g.Nodes[obj.IRI()]
	for i := range n.InverseEdge {
		if subj, ok := mod.mThing[n.InverseEdge[i].Subject.Term.String()]; ok {
			subj.RemoveObject(obj, n.InverseEdge[i].Pred.String())
		}
	}
	delete(mod.mSarefStartState, obj.IRI())
	delete(mod.mSarefStartCommand, obj.IRI())
	delete(mod.mSarefLightSwitch, obj.IRI())
	delete(mod.mTimeTemporalDuration, obj.IRI())
	delete(mod.mTimeZone, obj.IRI())
	delete(mod.mSarefSmoke, obj.IRI())
	delete(mod.mSarefEnergyUnit, obj.IRI())
	delete(mod.mSarefOpenState, obj.IRI())
	delete(mod.mSarefLoad, obj.IRI())
	delete(mod.mTimeInterval, obj.IRI())
	delete(mod.mSarefMeter, obj.IRI())
	delete(mod.mSarefSetAbsoluteLevelCommand, obj.IRI())
	delete(mod.mTimeDateTimeInterval, obj.IRI())
	delete(mod.mSarefWater, obj.IRI())
	delete(mod.mSarefStepDownCommand, obj.IRI())
	delete(mod.mSarefEnergy, obj.IRI())
	delete(mod.mSarefToggleCommand, obj.IRI())
	delete(mod.mTimeTemporalEntity, obj.IRI())
	delete(mod.mTimeTemporalUnit, obj.IRI())
	delete(mod.mSarefEnergyMeter, obj.IRI())
	delete(mod.mSarefCommand, obj.IRI())
	delete(mod.mSarefCloseState, obj.IRI())
	delete(mod.mSarefDoorSwitch, obj.IRI())
	delete(mod.mSarefLight, obj.IRI())
	delete(mod.mTimeProperInterval, obj.IRI())
	delete(mod.mTimeMonthOfYear, obj.IRI())
	delete(mod.mSarefService, obj.IRI())
	delete(mod.mSarefAppliance, obj.IRI())
	delete(mod.mSarefLightingDevice, obj.IRI())
	delete(mod.mSarefPressure, obj.IRI())
	delete(mod.mSarefOffCommand, obj.IRI())
	delete(mod.mSarefEventFunction, obj.IRI())
	delete(mod.mSarefActuator, obj.IRI())
	delete(mod.mSarefSensingFunction, obj.IRI())
	delete(mod.mSarefMultimedia, obj.IRI())
	delete(mod.mSarefState, obj.IRI())
	delete(mod.mTimeTemporalPosition, obj.IRI())
	delete(mod.mSarefGetCommand, obj.IRI())
	delete(mod.mTimeGeneralDateTimeDescription, obj.IRI())
	delete(mod.mSarefGetMeterDataCommand, obj.IRI())
	delete(mod.mSarefEnergyRelated, obj.IRI())
	delete(mod.mSarefSensor, obj.IRI())
	delete(mod.mSarefOccupancy, obj.IRI())
	delete(mod.mSarefProperty, obj.IRI())
	delete(mod.mSarefCurrency, obj.IRI())
	delete(mod.mTimeDateTimeDescription, obj.IRI())
	delete(mod.mSarefPressureUnit, obj.IRI())
	delete(mod.mSarefTask, obj.IRI())
	delete(mod.mSarefStopCommand, obj.IRI())
	delete(mod.mSarefMultiLevelState, obj.IRI())
	delete(mod.mSarefTemperatureSensor, obj.IRI())
	delete(mod.mSarefGetMeterHistoryCommand, obj.IRI())
	delete(mod.mTimePosition, obj.IRI())
	delete(mod.mSarefDevice, obj.IRI())
	delete(mod.mSarefSetLevelCommand, obj.IRI())
	delete(mod.mSarefLevelControlFunction, obj.IRI())
	delete(mod.mSarefBuildingRelated, obj.IRI())
	delete(mod.mSarefMotion, obj.IRI())
	delete(mod.mSarefNetwork, obj.IRI())
	delete(mod.mSarefGetSensingDataCommand, obj.IRI())
	delete(mod.mSarefOpenCloseFunction, obj.IRI())
	delete(mod.mSarefProfile, obj.IRI())
	delete(mod.mSarefPower, obj.IRI())
	delete(mod.mSarefOnCommand, obj.IRI())
	delete(mod.mSarefTemperatureUnit, obj.IRI())
	delete(mod.mSarefMicroRenewable, obj.IRI())
	delete(mod.mSarefUnitOfMeasure, obj.IRI())
	delete(mod.mSarefFunction, obj.IRI())
	delete(mod.mSarefOnOffState, obj.IRI())
	delete(mod.mTimeDuration, obj.IRI())
	delete(mod.mSarefStorage, obj.IRI())
	delete(mod.mSarefCloseCommand, obj.IRI())
	delete(mod.mSarefPrice, obj.IRI())
	delete(mod.mSarefStepUpCommand, obj.IRI())
	delete(mod.mSarefSmokeSensor, obj.IRI())
	delete(mod.mTimeTRS, obj.IRI())
	delete(mod.mSarefIlluminanceUnit, obj.IRI())
	delete(mod.mSarefCommodity, obj.IRI())
	delete(mod.mSarefActuatingFunction, obj.IRI())
	delete(mod.mSarefTemperature, obj.IRI())
	delete(mod.mSarefGetCurrentMeterValueCommand, obj.IRI())
	delete(mod.mSarefCoal, obj.IRI())
	delete(mod.mSarefOpenCommand, obj.IRI())
	delete(mod.mSarefOnState, obj.IRI())
	delete(mod.mSarefOffState, obj.IRI())
	delete(mod.mSarefGas, obj.IRI())
	delete(mod.mTimeDayOfWeek, obj.IRI())
	delete(mod.mSarefHVAC, obj.IRI())
	delete(mod.mSarefSwitch, obj.IRI())
	delete(mod.mSarefElectricity, obj.IRI())
	delete(mod.mSarefTime, obj.IRI())
	delete(mod.mTimeDurationDescription, obj.IRI())
	delete(mod.mSarefSetRelativeLevelCommand, obj.IRI())
	delete(mod.mSarefSwitchOnService, obj.IRI())
	delete(mod.mSarefGenerator, obj.IRI())
	delete(mod.mTimeGeneralDurationDescription, obj.IRI())
	delete(mod.mSarefStartStopFunction, obj.IRI())
	delete(mod.mSarefStartStopState, obj.IRI())
	delete(mod.mSarefMeteringFunction, obj.IRI())
	delete(mod.mSarefPauseCommand, obj.IRI())
	delete(mod.mSarefPowerUnit, obj.IRI())
	delete(mod.mSarefFunctionRelated, obj.IRI())
	delete(mod.mSarefNotifyCommand, obj.IRI())
	delete(mod.mSarefMeasurement, obj.IRI())
	delete(mod.mSarefOpenCloseState, obj.IRI())
	delete(mod.mSarefOnOffFunction, obj.IRI())
	delete(mod.mTimeInstant, obj.IRI())
	delete(mod.mSarefHumidity, obj.IRI())
	delete(mod.mSarefWashingMachine, obj.IRI())
	delete(mod.mSarefStopState, obj.IRI())
	delete(mod.mThing, obj.IRI())
	return
}

// String prints the model
func (mod *Model) String() (ret string) {
	ret = ""
	for i := range mod.mThing {
		ret += mod.mThing[i].String()
	}
	return
}

// ToDot writes a dot file from an existing model
func (mod* Model) ToDot(output io.Writer) (err error) {
	replace := make(map[string]string)
	shape := make(map[string]string)
	replace["https://w3id.org/saref#"] = "saref:"
	shape["https://w3id.org/saref#"] = "box"
	replace["http://www.wurvoc.org/vocabularies/om-1.8/"] = "om:"
	replace["http://www.w3.org/1999/02/22-rdf-syntax-ns#"] = "rdf:"
	replace["http://www.w3.org/2000/01/rdf-schema#"] = "rdfs:"
	g := mod.ToGraph()
	g.ToGraphvizDot(output, replace, shape)
	return
}


